function H=fasthist(x);
// H=fasthist(x)
//
// calculating the histogram of an array or vector
//
// the vector or array x is converted to INT values at first.
// Then the histogram vector H is calculated. H is a vector of
// length max(x) and has sparse structure.
//
// Example:
// x=rand(4,6)*10+1;
// H=fasthist(x);
//
// H should be now a vector of length 10.
// The sum(H) command should deliver the value 24 (Number of elements of x)

x=int(x);
if min(x)<=0,
	disp('Vektor may contain only positive values  ...');
	disp('--------------------------------------------');
	return;
end
x=x(:).';
xmax=max(x);

px=[ones(1,length(x));x].';

H=sparse(px,ones(x),[1,xmax]);

endfunction