function H=histcalc(x);
// H=histcalc(x)
//
// Histogram of a vector or a matrix
//
// The vector or matrix x is converted to integer.
// A histogram vector with max(x)-Elements is created.
// Each position J of the vector H contains the number of elements
// of x, which have the value J.
//
// H is a sparse vector !
//
// The execution time is dependent on the different kind of
// entries of x. It is not mainly dependant on the size of x!
//
// Much faster is the function fasthist !

[zx,sx]=size(x);
x=int(x);

if min(x)<=0,
	disp('Vector may contain only positive values  ...');
	disp('--------------------------------------------');
	return;
end

range_min=min(x);
range_max=max(x);
H=spzeros(1,range_max);

while ~isempty(x),
  minx=min(x);
  if minx>0,
    kcount=length(find(x==minx));
    H(minx)=kcount;
  end
  x=x(x~=minx);
end

endfunction