function [QT,QM]=huffcode(x);
// HUFFCODE
//		[QT,QM]=HUFFCODE(X)
//		Huffman-Codierung des Vektors X
//		X	: Vektor mit positiven Werten
//		QM	: Codierungstabelle
//		QT	: Binres Ausgangssignal nach Codierung
//
//		Bentigt wird die Prozedur "HUFFMAN.M"


x=int(x);				        // Histogramm
if min(x)<=0,
	disp('Vector may contain only positive values  ...');
	disp('--------------------------------------------');
	return;
end

xmax=max(x);

h=fasthist(x);
h=full(h);
w=bool2s(h>0);
w=cumsum(w);
x=w(x);

[SB,H,L,QM]=huffman(h);			// Huffman Coding
					            // Code table = QM
S=[];
QTab=[];

for p=1:1:size(QM,1),
	K=strindex(QM(p,:),':');
	QTabakt=part(QM(p,1),K(1)+1:K(2)-1);		// Only Codes
	QTab=[QTab;QTabakt];
end

QT=strcat(QTab(x));

endfunction