function [SB,h,L,QM]=huffman(h);
// HUFFMAN
//		[SB,H,L,QM]=HUFFMAN(H)
//		Huffman-Coding
//
//		H	:	Histogram Vector
//		SB	:	Symbol vector (0,1,..)
//		H	:	Vector with rel. propabilities
//		L	:	Symbol length after Huffman coding
//		QM	:	Stringarray with symbols and their codings

h=full(h);
h=h(:).';
h=h ./sum(h);					// rel. propability
SB=1:1:(length(h));				// Symbols

hcs=cumsum(h);
h=h(hcs>0);
SB=SB(hcs>0);

SB=SB(h>0);
h=h(h>0);

[hs,k]=gsort(h);				// Decreasing sorting
SB=SB(k);					    // by propability

SB=SB(hs>0);					// Eliminate non-existing symbols
hs=hs(hs>0);

NSB=length(SB);					// Number of existing symbols
						        // (propability > 0)

hakt=hs;					    // prepare while-loop
q=length(hakt);
q2=0;

VC=spzeros(NSB,1);				// create Codetree
while q>1,
	vc=[149 .*zeros(NSB-2-q2,1);48;49;149 .*zeros(q2,1)];
	VC=[VC,vc];
	q2=q2+1;
	hakt(length(hakt)-1)=hakt(length(hakt)-1)+hakt(length(hakt));
	hakt=hakt(1:length(hakt)-1);

	[hakt,k]=gsort(hakt);
	k=[k,max(k)+1:NSB];

	SB=SB(k);
	VC=VC(k,:);
	q=q-1;

end

[SB,k]=gsort(SB(:),'g','i');	// Sort by symbols (increasing)
VC=VC(k,:);
[zv,sv]=size(VC);
VC=VC(:,$:-1:1);				// Flip Left<->Right

WB=string(SB);
QM=[];
L=[];

for k=1:1:NSB,					// Codetree auslesen und Symbol-
	q=[];					    // codierungen auslesen
	zneu=k;
	sakt=sv;
	
	while sakt>0,
		[z,s,v]=mtlb_find(VC(zneu,1:sakt));
        z=z(:); s=s(:); v=v(:);
		vtmp=v.' - 48;
		vtmp=vtmp(:,$:-1:1);
		q=[q,vtmp]; 
		[zneu,sneu,vs]=mtlb_find(VC(:,min(s)));
        zneu=zneu(:); sneu=sneu(:); vs=vs(:);
		zneu=zneu(zneu~=k);
		sakt=min(s)-1;
	end

	Q=[str2code(string(WB(k,:))).',44,(q(:,$:-1:1)),44,str2code(string(length(q))).'];
	QM=[QM;code2str(Q)];
	L=[L;length(q)];
end
h=h(h>0);

endfunction;